import {
    world,
    system,
} from "@minecraft/server"
import {
    Mana
} from "./main.js"

export function getHealth() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Mainhand")
        if (player?.getEntitiesFromViewDirection({ maxDistance: 7 }).length != 0 && player.getEntitiesFromViewDirection({ maxDistance: 7 }).pop().entity.hasComponent("minecraft:health") == true && player.getEntitiesFromViewDirection({ maxDistance: 7 }).pop().entity.getComponent("minecraft:health").effectiveMax <= 75) { //Checks if the player is staring at an entity, if they have the health component, and if they do, if their max health is less than 75
            if (item?.hasTag("minecraft:is_sword") || item?.hasTag("minecraft:is_axe") || item?.hasTag("magicraft:is_greatsword") || item?.hasTag("magicraft:is_battleaxe") || item?.hasTag("magicraft:is_saber") || item?.hasTag("magicraft:is_dagger")) { //Checks if the player is holding a weapon
                const getEntity = player.getEntitiesFromViewDirection({ maxDistance: 7 }).pop().entity
                //const name = getEntity.typeId.split(":", 2).pop().charAt(0).toUpperCase() + getEntity.typeId.split(":", 2).pop().slice(1).toLowerCase()

                const health = "|".repeat(getEntity.getComponent("minecraft:health").currentValue.toFixed(0))
                const whitespace = "|".repeat(getEntity.getComponent("minecraft:health").effectiveMax.toFixed(0) - getEntity.getComponent("minecraft:health").currentValue.toFixed(0))
                const mana = "|".repeat(Mana)
                const whitespace2 = "|".repeat((30 - Mana))

                player.onScreenDisplay.setActionBar("[§c" + health + "§r" + whitespace + "] / [§9" + mana + "§r" + whitespace2 + "]")
                system.run(getHealth)
            }
            else {
                system.run(getHealth)
            }
        }
        else {
            system.run(getHealth)
        }
    }
}


export function amulets() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Offhand")

        if (item?.hasTag("magicraft:is_amulet")) { //Check if the player has an amulet in their offhand
            const damage = item?.getComponent("durability").damage;
            const durability = item?.getComponent("durability").maxDurability;

            if (item?.typeId == "magicraft:amulet_haste") {
                player.addEffect("haste", 10, { showParticles: false, amplifier: 0 })
                system.run(amulets)

                if (system.currentTick % 200 == 0) {
                    if (damage == durability) {
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(null)
                    }
                    else {
                        item.getComponent("durability").damage += 1;
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(item)
                    }
                }
            }
            else if (item?.typeId == "magicraft:amulet_speed") {
                player.addEffect("speed", 10, { showParticles: false, amplifier: 0 })
                system.run(amulets)

                if (system.currentTick % 200 == 0) {
                    if (damage == durability) {
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(null)
                    }
                    else {
                        item.getComponent("durability").damage += 1;
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(item)
                    }
                }
            }
            else if (item?.typeId == "magicraft:amulet_slowfall") {
                player.addEffect("slow_falling", 10, { showParticles: false, amplifier: 0 })
                system.run(amulets)

                if (system.currentTick % 200 == 0) {
                    if (damage >= durability) {
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(null)
                    }
                    else {
                        item.getComponent("durability").damage += 1;
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(item)
                    }
                }
            }
            else if (item?.typeId == "magicraft:amulet_strength") {
                player.addEffect("strength", 10, { showParticles: false, amplifier: 0 })
                system.run(amulets)

                if (system.currentTick % 200 == 0) {
                    if (damage >= durability) {
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(null)
                    }
                    else {
                        item.getComponent("durability").damage += 1;
                        player.getComponent("equippable").getEquipmentSlot("Offhand").setItem(item)
                    }
                }
            }
        }
        else {
            system.run(amulets)
        }
    }
}

export function showMana() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Mainhand")
        const mana = "|".repeat(Mana)
        const whitespace = "|".repeat((30 - Mana))

        if (item?.hasTag("magicraft:is_spell") || item?.hasTag("magicraft:is_staff") || item?.hasTag("magicraft:is_attack_staff") || item?.typeId == "magicraft:darkbloom_potion") {
            player.onScreenDisplay.setActionBar("[§9" + mana + "§r" + whitespace + "]")
            system.run(showMana)
        }
        else {
            system.run(showMana)
        }
    }
}

export function teleportSound() {
    for (const player of world.getPlayers()) {
        player.playSound("mob.endermen.portal")
    }
}